package dev.shadowsoffire.apotheosis.advancements;

package .tmp;

import com.google.common.collect.Maps;
import com.google.gson.JsonObject;
import dev.shadowsoffire.apotheosis.advancements.GemCutTrigger;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityRegistry;
import java.util.Map;
import net.minecraft.advancements.CriterionTrigger;
import net.minecraft.advancements.CriterionTriggerInstance;
import net.minecraft.advancements.critereon.DeserializationContext;
import net.minecraft.advancements.critereon.ItemPredicate;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.server.PlayerAdvancements;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.util.GsonHelper;
import net.minecraft.world.item.ItemStack;

public class GemCutTrigger implements CriterionTrigger<GemCutTrigger.Instance> {
  private static final ResourceLocation ID = new ResourceLocation("apotheosis", "gem_cutting");
  
  private final Map<PlayerAdvancements, Listeners> listeners = Maps.newHashMap();
  
  public ResourceLocation m_7295_() {
    return ID;
  }
  
  public void m_6467_(PlayerAdvancements playerAdvancementsIn, CriterionTrigger.Listener<Instance> listener) {
    Listeners ModifierTrigger$listeners = this.listeners.get(playerAdvancementsIn);
    if (ModifierTrigger$listeners == null) {
      ModifierTrigger$listeners = new Listeners(playerAdvancementsIn);
      this.listeners.put(playerAdvancementsIn, ModifierTrigger$listeners);
    } 
    ModifierTrigger$listeners.add(listener);
  }
  
  public void m_6468_(PlayerAdvancements playerAdvancementsIn, CriterionTrigger.Listener<Instance> listener) {
    Listeners ModifierTrigger$listeners = this.listeners.get(playerAdvancementsIn);
    if (ModifierTrigger$listeners != null) {
      ModifierTrigger$listeners.remove(listener);
      if (ModifierTrigger$listeners.isEmpty())
        this.listeners.remove(playerAdvancementsIn); 
    } 
  }
  
  public void m_5656_(PlayerAdvancements playerAdvancementsIn) {
    this.listeners.remove(playerAdvancementsIn);
  }
  
  public Instance createInstance(JsonObject json, DeserializationContext conditionsParser) {
    json = json.getAsJsonObject("conditions");
    if (json != null) {
      ItemPredicate item = ItemPredicate.m_45051_(json.get("item"));
      ResourceLocation rarity = RarityRegistry.convertId(GsonHelper.m_13851_(json, "rarity", ""));
      return new Instance(item, rarity);
    } 
    return new Instance(ItemPredicate.f_45028_, new ResourceLocation(""));
  }
  
  public void trigger(ServerPlayer player, ItemStack stack, ResourceLocation rarity) {
    Listeners ModifierTrigger$listeners = this.listeners.get(player.m_8960_());
    if (ModifierTrigger$listeners != null)
      ModifierTrigger$listeners.trigger(stack, rarity); 
  }
}
